﻿Imports System
Imports System.Collections.Generic
Imports System.Text
'step1. reference nmodbuspc.dll, and using the namespaces.
Imports Modbus.Device      'for modbus master
Imports System.IO.Ports    'for controlling serial ports
Imports System.Net.Sockets

Module input_status

    Private serialPort As New SerialPort()
    Private master As ModbusSerialMaster
    Sub main()

        ' create a new SerialPort object with default settings.
        serialPort = New SerialPort()

        ' set the appropriate properties
        serialPort.PortName = "COM1"    'the COM port connected to WISE COM1(RS-232)
        serialPort.BaudRate = 115200
        serialPort.Parity = Parity.None
        serialPort.StopBits = StopBits.One
        serialPort.DataBits = 8
        serialPort.Open()

        ' create Modbus RTU Master by the comport client
        'document->Modbus.Device.Namespace->ModbusSerialMaster Class->CreateRtu Method
        master = ModbusSerialMaster.CreateRtu(serialPort)

        ' read the input status 20~29 (10020~10029, DI ch0 ~ ch9) of the WISE module.
        'document->Modbus.Device.Namespace->ModbusMaster Class->ReadInput Method         
        Dim slaveID As Byte = 1
        Dim startAddress As UShort = 20
        Dim numOfPoints As UShort = 10
        master.Transport.ReadTimeout = 300

        Try

            Dim status() As Boolean = master.ReadInputs(slaveID, startAddress, numOfPoints)
            For index As Integer = 0 To status.Length - 1
                Console.WriteLine(String.Format("DI[{0}] = {1}", index, status(index)))
            Next index

        Catch ex As Exception
            Console.WriteLine(ex.Message)
        End Try

        Console.WriteLine("Press enter to exit....")
        Console.ReadLine()
    End Sub
End Module
