﻿Imports System
Imports System.Collections.Generic
Imports System.Text
'step1. reference nmodbuspc.dll, and using the namespaces.
Imports Modbus.Device      'for modbus master
Imports System.Net         'for tcp client
Imports System.Net.Sockets

Module coil_status

    Private tcpClient As TcpClient
    Private master As ModbusIpMaster
    Sub main()

        ' connect to Modbus TCP Server
        Dim ipAddress As String = "127.0.0.1"   'Input WISE IP
        Dim tcpPort As Integer = 502
        tcpClient = New TcpClient(ipAddress, tcpPort)

        ' create Modbus TCP Master by the tcp client
        'document->Modbus.Device.Namespace->ModbusIpMaster Class->Create Method
        master = ModbusIpMaster.CreateIp(tcpClient)

        ' rewrite the value of address 20 (WISE DO channel 0)
        'document->Modbus.Device.Namespace->ModbusMaster Class->WriteSingleCoil Method 
        Dim slaveID As Byte = 1
        Dim rewriteAddress As UShort = 20
        Dim rewriteValue As Boolean = True
        master.WriteSingleCoil(slaveID, rewriteAddress, rewriteValue)

        ' read the coil status 20~29 (00020~00029, DO ch0 ~ ch9) of the WISE module. 
        'document->Modbus.Device.Namespace->ModbusMaster Class->ReadCoils Method            
        Dim startAddress As UShort = 20
        Dim numOfPoints As UShort = 10
        master.Transport.ReadTimeout = 1000

        Try

            Dim status() As Boolean = master.ReadCoils(slaveID, startAddress, numOfPoints)
            For index As Integer = 0 To status.Length - 1
                Console.WriteLine(String.Format("DO[{0}] = {1}", index, status(index)))
            Next index

        Catch ex As Exception
            Console.WriteLine(ex.Message)
        End Try

        Console.WriteLine("Press enter to exit....")
        Console.ReadLine()
    End Sub
End Module
