﻿Imports System
Imports System.Collections.Generic
Imports System.Text
'step1. reference nmodbuspc.dll, and using the namespaces.
Imports Modbus.Device      'for modbus master
Imports System.Net         'for tcp client
Imports System.Net.Sockets

Module holding_register

    Private tcpClient As TcpClient
    Private master As ModbusIpMaster
    Sub main()

        ' connect to Modbus TCP Server
        Dim ipAddress As String = "127.0.0.1"   'Input WISE IP
        Dim tcpPort As Integer = 502
        tcpClient = New TcpClient(ipAddress, tcpPort)

        ' create Modbus TCP Master by the tcp client
        'document->Modbus.Device.Namespace->ModbusIpMaster Class->Create Method
        master = ModbusIpMaster.CreateIp(tcpClient)

        ' rewrite the value of AO ch0 (40020~40021) by float
        'document->Modbus.Device.Namespace->ModbusMaster Class->WriteSingleRegister Method 
        Dim slaveID As Byte = 1
        Dim rewriteAddress As UShort = 20
        Dim rewriteValue() As UShort = New UShort(1) {0, 0}
        Dim floatData() As Single = New Single(0) {223.456F}
        Buffer.BlockCopy(floatData, 0, rewriteValue, 0, 4)
        For index As UShort = 0 To 1
            master.WriteSingleRegister(slaveID, rewriteAddress + index, rewriteValue(index))
        Next index

        ' read the holding register 20~29 (40020~40029, AO ch0 ~ ch4, float type) of the WISE module.
        'document->Modbus.Device.Namespace->ModbusMaster Class->ReadHoldingRegisters Method           
        Dim startAddress As UShort = 20
        Dim numOfPoints As UShort = 10
        master.Transport.ReadTimeout = 1000

        Try

            Dim register() As UShort = master.ReadHoldingRegisters(slaveID, startAddress, numOfPoints)
            Dim floatData2() As Single = {0, 0, 0, 0, 0}
            Buffer.BlockCopy(register, 0, floatData2, 0, register.Length * 2)
            For index As Integer = 0 To floatData2.Length - 1
                Console.WriteLine(String.Format("AO[{0}] = {1}", index, floatData2(index)))
            Next index

        Catch ex As Exception
            Console.WriteLine(ex.Message)
        End Try

        Console.WriteLine("Press enter to exit....")
        Console.ReadLine()
    End Sub
End Module
