﻿Imports System
Imports System.Collections.Generic
Imports System.Text
'step1. reference nmodbuspc.dll, and using the namespaces.
Imports Modbus.Device      'for modbus master
Imports System.Net         'for tcp client
Imports System.Net.Sockets


Module input_register

    Private tcpClient As TcpClient
    Private master As ModbusIpMaster
    Sub main()

        ' connect to Modbus TCP Server
        Dim ipAddress As String = "10.0.0.188"  'Input WISE IP
        Dim tcpPort As Integer = 502
        tcpClient = New TcpClient(ipAddress, tcpPort)

        ' create Modbus TCP Master by the tcp client
        'document->Modbus.Device.Namespace->ModbusIpMaster Class->Create Method
        master = ModbusIpMaster.CreateIp(tcpClient)

        ' read the input register 20~29 (30020~30029, AI ch0 ~ ch4, float type) of the WISE module.
        'document->Modbus.Device.Namespace->ModbusMaster Class->ReadInputRegisters Method            
        Dim slaveID As Byte = 1
        Dim startAddress As UShort = 20
        Dim numOfPoints As UShort = 10
        master.Transport.ReadTimeout = 1000

        Try

            Dim register() As UShort = master.ReadInputRegisters(slaveID, startAddress, numOfPoints)
            Dim floatData() As Single = {0, 0, 0, 0, 0}
            Buffer.BlockCopy(register, 0, floatData, 0, register.Length * 2)
            For index As Integer = 0 To floatData.Length - 1
                Console.WriteLine(String.Format("AI[{0}] = {1}", index, floatData(index)))
            Next index

        Catch ex As Exception
            Console.WriteLine(ex.Message)
        End Try
        Console.WriteLine("Press enter to exit....")
        Console.ReadLine()
    End Sub
End Module
